<?php
/**
 * Helper class which manages texts and plugin and shop versions.
 *
 * @package GiroCheckout
 */
class GiroCheckout_Utility {
  /*
   * contains texts in different languages
   */

  private static $aTexts = array( 'de' => array( 'merchantid' => "Verkäufer-ID",
                                                 'projectid' => "Projekt-ID",
                                                 'secret' => "Projekt-Passwort",
                                                 'info' => "Die Daten für die Einstellungen entnehmen Sie bitte dem Projekt-Profil in Ihrem GiroCockpit (www.girocockpit.de).",
                                                 'continuetopayment' => 'Weiter zur Bezahlung',
                                                 'paymentcompleted' => 'Bezahlung abgeschlossen',
                                                 'gotocockpit' => 'Ihre Projekt-Daten erhalten Sie in Ihrem GiroCockpit unter www.girosolution.de/user.',
                                                 'continuetopayment' => 'Weiter zur Bezahlung',
                                                 'backtoprevious' => 'Zurück',
                                                 'purpose' => "Verwendungszweck",
                                                 'purpose_desc' => 'Sie können in Ihrem Verwendungszweck die folgenden Platzhalter verwenden:
                                                                    <ul>
                                                                      <li style="list-style: inherit;">{ORDERID}: Bestellnummer</li>
                                                                      <li style="list-style: inherit;">{CUSTOMERID}: Kundennummer</li>
                                                                      <li style="list-style: inherit;">{SHOPNAME}: Shop Name</li> 
                                                                      <li style="list-style: inherit;">{CUSTOMERNAME}: Kundenname</li>
                                                                      <li style="list-style: inherit;">{CUSTOMERFIRSTNAME}: Kunde Vorname</li>
                                                                      <li style="list-style: inherit;">{CUSTOMERLASTNAME}: Kunde Nachname</li>
                                                                    </ul>
                                                                    Beispiel: Wenn Ihr Verwendungszweck "Best. 55342, TestShop" lauten soll, dann müssen Sie folgendes angeben: "Best. {ORDERID}, {SHOPNAME}".
                                                                    Die maximale Länge beträgt 27 Zeichen.',      
                                                 'settings_missing' => 'Diese Zahlungsart muss von einem Administrator konfiguriert werden, bevor sie verwendet werden kann.',
                                                 'use_external_form_service' => 'Externen Formularservice verwenden',
                                                 'gc_giropay' => array( 'title' => "giropay - online überweisen",
                                                                        'description' => "Mit giropay zahlen Sie einfach, schnell und sicher im Online-Banking Ihrer teilnehmenden Bank oder Sparkasse. Sie werden direkt zum Online-Banking Ihrer Bank weitergeleitet, wo Sie die Überweisung durch Eingabe von PIN und TAN freigeben.",
                                                                        'bank_selection' => "Ihre Bank",
                                                                        'hint_text' => "(Suchen Sie nach Bankname, BLZ, Ort oder BIC.)"),
                                                 'gc_directdebit' => array( 'title' => "Lastschrift",
                                                                            'description' => "Hiermit ermächtigen Sie uns, den fälligen Betrag von Ihrem Konto mittels Lastschrift einzuziehen.",
                                                                            'IBAN' => "IBAN",
                                                                            'bank_code' => "BLZ",
                                                                            'bank_account' => "Kontonummer",
                                                                            'rbDirectdebit' => "Kontonummer",
                                                                            'account_holder' => "Kontoinhaber",
                                                                            'bank_blz' => "Kontonummer/BLZ verwenden",
                                                                            'show_bank' => "Zeige Kontonummer/ BLZ Eingabefeld"),
                                                 'gc_creditcard' => array(  'title' => "Kreditkarte",
                                                                            'description' => "Im nächsten Schritt werden Sie aufgefordert, Ihre Kreditkartendaten einzugeben. Wenn Ihre Kreditkarte für 3D-Secure (Verified by Visa bzw. MasterCard SecureCode) freigeschaltet ist, werden Sie während des Bezahlprozesses zur Sicherheitsabfrage Ihrer Bank weitergeleitet.",
                                                                            'visa' => "Visa/Mastercard",
                                                                            'amex' => "AMEX",
                                                                            'jcb' => "JCB"),
                                                 'gc_ideal' => array( 'title' => "iDEAL Online überweisen (NL)",
                                                                      'description' => "iDEAL ist das Online Überweisungssystem der niederländischen Banken, das auf dem etablierten Onlinebanking-Verfahren der Kreditinstitute basiert. Im folgenden müssen Sie Ihre Bank auswählen und können anschließend die Zahlung in Ihrem Online-Banking durchführen.",
                                                                      'issuer' => "Bank" ),
                                                 'gc_eps' => array( 'title' => "eps - Online überweisung",
                                                                    'description' => "Mit eps Online-Überweisung zahlen Sie einfach, schnell und sicher im Online-Banking Ihrer Bank. Im nächsten Schritt werden Sie direkt zum Online-Banking Ihrer Bank weitergeleitet, wo Sie die Zahlung durch Eingabe von PIN und TAN freigeben.",
                                                                    'bank_selection' => "Ihre Bank",
                                                                    'hint_text' => "(Suchen Sie nach Bankname, BLZ, Ort oder BIC.)" ),
                                                 'gc_paydirekt' => array( 'title' => "Paydirekt",
                                                                          'description' => "Das Online-Bezahlverfahren Ihrer Banken und Sparkassen. Sie werden auf die Webseiten von Paydirekt weitergeleitet, wo Sie sich mit Ihren persönlichen Zugangsdaten anmelden und dann die Zahlung bestätigen. Sie benötigen vorab eine Registrierung bei Paydirekt." ),
                                                 'gc_sofortuw' => array( 'title' => "SOFORT Überweisung",
                                                                          'description' => "Mit SOFORT Überweisung geht das online Bezahlen einfach wie nie! Sie nutzen dabei ganz bequem Ihre vertrauten Online-Banking Daten und sind so auf der sicheren Seite. Sie werden auf die SOFORT-Webseiten weiter geleitet, geben dort Ihre Bankdaten ein und lösen die Online-Überweisung aus." ),
                                                 'gc_giropaygpid' => array( 'title' => "giropay+giropayID",
                                                                            'description' => "Mit giropay+giropayID zahlen Sie einfach, schnell und sicher im Online-Banking Ihrer teilnehmenden Bank oder Sparkasse mit integrierter Altersverifikation. Sie werden direkt zum Online-Banking Ihrer Bank weitergeleitet, wo Sie die Überweisung durch Eingabe von PIN und TAN freigeben.",
                                                                            'bank_selection' => "Ihre Bank",
                                                                            'hint_text' => "(Suchen Sie nach Bankname, BLZ, Ort oder BIC.)"),       
                                               ) ,
                                  'en' => array( 'merchantid' => "Merchant ID",
                                                 'projectid' => "Project ID",
                                                 'secret' => "Project password",
                                                 'info' => "",
                                                 'purpose' => "Purpose",
                                                 'purpose_desc' => 'You can define your own purpose using this placeholders:
                                                                    <ul>
                                                                      <li style="list-style: inherit;">{ORDERID}: Bestellnummer</li>
                                                                      <li style="list-style: inherit;">{CUSTOMERID}: Kundennummer</li>
                                                                      <li style="list-style: inherit;">{SHOPNAME}: Shop Name</li> 
                                                                      <li style="list-style: inherit;">{CUSTOMERNAME}: Kundenname</li>
                                                                      <li style="list-style: inherit;">{CUSTOMERFIRSTNAME}: Kunde Vorname</li> 
                                                                      <li style="list-style: inherit;">{CUSTOMERLASTNAME}: Kunde Nachname</li>
                                                                    </ul>
                                                                    For example: If your purpose is "Best. {ORDERID}, {SHOPNAME}" then the submitted purpose must be "Best. 55342, TestShop"
                                                                    The maximum length of the purpose is 27 characters.',
                                                 'continuetopayment' => 'Continue with payment',
                                                 'paymentcompleted' => 'Payment completed',
                                                 'gotocockpit' => 'Your project details are available in your GiroCockpit, please go to www.girosolution.de/user.',                                                 
                                                 'continuetopayment' => 'Continue with payment',
                                                 'backtoprevious' => 'Back',
                                                 'settings_missing' => 'This payment method must be configured by an administrator before it can be used.',
                                                 'use_external_form_service' => 'Use external form service',
                                                 'gc_giropay' => array( 'title' => "giropay - online bank transfer",
                                                                        'description' => "With giropay you pay simply, fast and secure by the online banking of your participating bank. You will be redirected to the online banking of your bank where you authorize the credit transfer.",
                                                                        'bank_selection' => "bank",
                                                                        'hint_text' => "(Search by bank name, bank code, city or bic.)"),
                                                 'gc_directdebit' => array( 'title' => "direct debit",
                                                                            'description' => "Hereby you authorize us to charge your current account with the invoiced amount by direct debit.",
                                                                            'IBAN' => "iban",
                                                                            'bank_code' => "bank code",
                                                                            'bank_account' => "bank account",
                                                                            'rbDirectdebit' => "bank account",
                                                                            'account_holder' => "account holder",
                                                                            'bank_blz' => "bank account/bank code",
                                                                            'show_bank' => "Show Bank Account/ Bank Code input field"),
                                                 'gc_creditcard' => array( 'title' => "credit card",
                                                                           'description' => "On the following secure website, you are asked to enter your credit card data. If your credit card is enabled for 3D Secure (Verified by Visa or MasterCard Secure Code), additional information will be passed for a security check at your bank.",
                                                                           'visa' => "Visa/Mastercard",
                                                                           'amex' => "AMEX",
                                                                           'jcb' => "JCB"),
                                                 'gc_ideal' => array( 'title' => "iDEAL-online bank transfer (NL)",
                                                                      'description' => "With iDEAL you pay simply, fast and secure by online banking of your bank. You will be redirected to the online banking of your bank where you authorize the credit transfer with PIN and TAN.",
                                                                      'issuer' => "issuer" ),
                                                 'gc_eps' => array( 'title' => "eps - online bank transfer (AT)",
                                                                    'description' => "With eps online transfer you pay simply, fast and secure by online banking of your bank. Your will be redirected to the online banking at your bank where you authorize the credit transfer with PIN and TAN.",
                                                                    'bank_selection' => "bank",
                                                                    'hint_text' => "(Search by bank name, bank code, city or bic.)"),
                                                 'gc_paydirekt' => array( 'title' => "Paydirekt",
                                                                          'description' => "The online payment method of the German banks and Sparkassen. You will be redirected to the Paydirekt web site, where you will log into your personal account and authorize the payment. You require prior registration with Paydirekt. This payment method only works with German banking accounts." ),
                                                 'gc_sofortuw' => array( 'title' => "SOFORT Überweisung",
                                                                          'description' => "Direct payment via online banking. Make payments the easy way with your own online banking details – fast and direct. You will be redirected to the web site of SOFORT, where you will enter your banking data and initiate the electronic wire transfer." ),
                                                 'gc_giropaygpid' => array( 'title' => "giropay+giropayID",
                                                                            'description' => "With giropay+giropayID you pay simply, quickly and securely through the online banking of your participating bank, with included age verification. You will be redirected to the online banking of your bank where you authorize the credit transfer.",
                                                                            'bank_selection' => "bank",
                                                                            'hint_text' => "(Search by bank name, bank code, city or bic.)"),       
                                                ) );
  
  /**
   * Get the plugin payments method texts.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @param type $id The text key
   * @param type $pm The payment method key
   * @return string, the text
   */
  public static function getText($id, $lang, $pm = 'default') {
    if (strtolower($lang) == 'de' || strtolower($lang) == 'en') {
      $strlang = strtolower($lang);
    } else {
      $strlang = 'en';
    }

    if (empty($pm) || $pm == 'default') {
      return self::$aTexts[$strlang][$id];
    } else {
      return self::$aTexts[$strlang][$pm][$id];
    }
  }
  
  /**
   * Returns plugin version.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return string
   */
  public static function getVersion() {
    return '3.0.1';
  }

  /**
   * Returns plugin and shop version.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return string
   */
  public static function getGcSource() {
    return "Drupal " . VERSION . ";Drupal Ubercart Plugin " . self::getVersion();
  }
  
  public static function getLanguageTexts($lang) {
    return self::$aTexts[$lang];
  }
  
  /**
   * Get the payment purpose.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return int
   */
  public static function getPurpose($purpose,$order) {
    $strPurpose = $purpose;
    $strLastName = "";
    $strFirstName = "";  
    $strShopName = "";
    
    $iCustomerNr = $order->uid;
    $strLastName = $order->billing_last_name;
    $strFirstName = $order->billing_first_name;
    $strName = $order->billing_first_name . ", " . $order->billing_last_name;
    
    $strShopName = variable_get('site_name');

    $strPurpose = str_replace( "{ORDERID}", $order->order_id, $strPurpose );
    $strPurpose = str_replace( "{CUSTOMERID}", $iCustomerNr, $strPurpose );
    $strPurpose = str_replace( "{SHOPNAME}", $strShopName, $strPurpose );
    $strPurpose = str_replace( "{CUSTOMERNAME}", $strName, $strPurpose );
    $strPurpose = str_replace( "{CUSTOMERFIRSTNAME}", $strFirstName, $strPurpose );
    $strPurpose = str_replace( "{CUSTOMERLASTNAME}", $strLastName, $strPurpose );

    return utf8_encode(trim(substr($strPurpose, 0, 27)));
  }    
  
  /**
   * Get the extended logo for creditcards.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return string
   */
  public static function getExtendedLogo() {
    $visa_mscvar = variable_get('gc_creditcard_visa', '');
    $amexvar = variable_get('gc_creditcard_amex', '');
    $jcbvar = variable_get('gc_creditcard_jcb', '');

    if( $visa_mscvar == 1 )
      $visa_msc = true;
    else
      $visa_msc = false;

    if( $amexvar == 1 )
      $amex = true;
    else
      $amex = false;

    if( $jcbvar == 1 )
      $jcb = true;
    else
      $jcb = false;

    if( !$visa_msc && !$amex && !$jcb )
      $visa_msc = true;

    return GiroCheckout_SDK_Tools::getCreditCardLogoName($visa_msc, $amex, $jcb);
  }

  public static function formatText($string) {
    return utf8_encode($string);
  }    
}
