<?php

/**
 * Payment Modul fur girosolution.de.
 *
 * @version   2.0.0
 * @author    OCS
 * @copyright 2011-2017 GiroSolution AG
 * @link      http://www.girosolution.de
 * @link      http://www.gambio.de
 * @license   http://opensource.org/licenses/gpl-2.0.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

/**
 * @file
 * The Ubercart file for the girocheckout module.
 */
function uc_girocheckout_get_pm_settings($pm) {
    $settings = array(
        $pm . '_mid' => variable_get($pm . '_mid', ''),
        $pm . '_pid' => variable_get($pm . '_pid', ''),
        $pm . '_secret' => variable_get($pm . '_secret', ''),
        $pm . '_purpose' => variable_get($pm . '_purpose', ''),
    );

		if ($pm == 'gc_creditcard') {
        $settings[$pm . '_visa'] = variable_get($pm . '_visa', '');
        $settings[$pm . '_amex'] = variable_get($pm . '_amex', '');
        $settings[$pm . '_jcb'] = variable_get($pm . '_jcb', '');
    }

    return $settings;
}

/**
 * TODO
 *
 * @param string $pm
 *   TODO
 *
 * @return array
 *   TODO
 */
function uc_girocheckout_pm_setting($pm, $settings = NULL) {
    global $language;

    if (empty($settings)) {
        $settings = uc_girocheckout_get_pm_settings($pm);
    }

    $form = array();
    $form[$pm . '_mid'] = array(
        '#type' => 'textfield',
        '#title' => GiroCheckout_Utility::getText('merchantid', $language->language),
        '#default_value' => (isset($settings[$pm . '_mid']) ? $settings[$pm . '_mid'] : ''),
    );
    $form[$pm . '_pid'] = array(
        '#type' => 'textfield',
        '#title' => GiroCheckout_Utility::getText('projectid', $language->language),
        '#default_value' => (isset($settings[$pm . '_pid']) ? $settings[$pm . '_pid'] : ''),
    );
    $form[$pm . '_secret'] = array(
        '#type' => 'textfield',
        '#title' => GiroCheckout_Utility::getText('secret', $language->language),
        '#default_value' => (isset($settings[$pm . '_secret']) ? $settings[$pm . '_secret'] : ''),
    );
    $form[$pm . '_purpose'] = array(
        '#type' => 'textfield',
        '#title' => GiroCheckout_Utility::getText('purpose', $language->language),
        '#default_value' => (isset($settings[$pm . '_purpose']) ? $settings[$pm . '_purpose'] : 'Best. {ORDERID}, {SHOPNAME}'),
        '#description' => t(GiroCheckout_Utility::getText('purpose_desc', $language->language)),
    );

		if ($pm == 'gc_creditcard') {
        $form[$pm . '_visa'] = array(
            '#type' => 'checkbox',
            '#title' => GiroCheckout_Utility::getText('visa', $language->language, $pm),
            '#default_value' => ((isset($settings[$pm . '_visa']) && $settings[$pm . '_visa']) ? '1' : '0'),
        );
        $form[$pm . '_amex'] = array(
            '#type' => 'checkbox',
            '#title' => GiroCheckout_Utility::getText('amex', $language->language, $pm),
            '#default_value' => ((isset($settings[$pm . '_amex']) && $settings[$pm . '_amex']) ? '1' : '0'),
        );
        $form[$pm . '_jcb'] = array(
            '#type' => 'checkbox',
            '#title' => GiroCheckout_Utility::getText('jcb', $language->language, $pm),
            '#default_value' => ((isset($settings[$pm . '_jcb']) && $settings[$pm . '_jcb']) ? '1' : '0'),
        );
    }
    
    $form['notice'] = array(
        '#markup' => '<div>' . GiroCheckout_Utility::getText('gotocockpit', $language->language) . '</div>',
    );

    return $form;
}

/**
 * TODO
 *
 * @param string $pm
 *   TODO
 *
 * @return array
 *   TODO
 */
function uc_girocheckout_cart_details($pm, &$form, &$values, $settings = NULL, $order = NULL) {
    global $language;


    if (empty($settings)) {
        $settings = uc_girocheckout_get_pm_settings($pm);
    }
    $values += array(
        'girocheckout_method' => $pm,
    );

    $form['girocheckout_method'] = array(
        '#type' => 'hidden',
        '#value' => $values['girocheckout_method']
    );

    switch ($pm) {
        case 'gc_giropay':
            $form['girocheckout_giropay_info'] = array(
                '#markup' => '<p><img src="' . base_path() . drupal_get_path('module', 'uc_girocheckout') . '/img/gc_giropay.jpg" alt="' . GiroCheckout_Utility::getText('title', $language->language, $pm) . '" style="float:left; margin:-5px 5px 0px 0px;">'
                . GiroCheckout_Utility::getText('title', $language->language, $pm) . '<br/><br/>' . GiroCheckout_Utility::getText('description', $language->language, $pm) . '</p>'
            );
            break;

        case 'gc_eps':
            $form['girocheckout_eps_info'] = array(
                '#markup' => '<p><img src="' . base_path() . drupal_get_path('module', 'uc_girocheckout') . '/img/gc_eps.jpg" alt="' . GiroCheckout_Utility::getText('title', $language->language, $pm) . '" style="float:left; margin:-5px 5px 0px 0px;">'
                . GiroCheckout_Utility::getText('title', $language->language, $pm) . '<br/><br/>' . GiroCheckout_Utility::getText('description', $language->language, $pm) . '</p>'
            );
            break;

        case 'gc_ideal':
            $form['girocheckout_ideal_info'] = array(
                '#markup' => '<p><img src="' . base_path() . drupal_get_path('module', 'uc_girocheckout') . '/img/gc_ideal.jpg" alt="' . GiroCheckout_Utility::getText('title', $language->language, $pm) . '" style="float:left; margin:-5px 5px 0px 0px;">'
                . GiroCheckout_Utility::getText('title', $language->language, $pm) . '<br/><br/>' . GiroCheckout_Utility::getText('description', $language->language, $pm) . '</p>'
            );
            break;

        case 'gc_directdebit':
            $form['girocheckout_directdebit_info'] = array(
                '#markup' => '<p><img src="' . base_path() . drupal_get_path('module', 'uc_girocheckout') . '/img/gc_directdebit.jpg" alt="' . GiroCheckout_Utility::getText('title', $language->language, $pm) . '" style="float:left; margin:-5px 5px 0px 0px;">'
                . GiroCheckout_Utility::getText('title', $language->language, $pm) . '<br/><br/>' . GiroCheckout_Utility::getText('description', $language->language, $pm) . '</p>'
            );
            break;

        case 'gc_creditcard':
            $strLogoName = GiroCheckout_Utility::getExtendedLogo();

            if (strlen($strLogoName) > 0) {
                $strImageCredit = $strLogoName;
            } else {
                $strImageCredit = 'gc_creditcard.jpg';
            }

            $form['girocheckout_creditcard_info'] = array(
                '#markup' => '<p><img src="' . base_path() . drupal_get_path('module', 'uc_girocheckout') . '/img/' . $strImageCredit . '" alt="' . GiroCheckout_Utility::getText('title', $language->language, $pm) . '" style="float:left; margin:-5px 5px 0px 0px;">'
                . GiroCheckout_Utility::getText('title', $language->language, $pm) . '<br/><br/>' . GiroCheckout_Utility::getText('description', $language->language, $pm) . '</p>'
            );
            break;

        case 'gc_paydirekt':
            $form['girocheckout_paydirekt_info'] = array(
                '#markup' => '<p><img src="' . base_path() . drupal_get_path('module', 'uc_girocheckout') . '/img/gc_paydirekt.jpg" alt="' . GiroCheckout_Utility::getText('title', $language->language, $pm) . '" style="float:left; margin:-5px 5px 0px 0px;">'
                . GiroCheckout_Utility::getText('title', $language->language, $pm) . '<br/><br/>' . GiroCheckout_Utility::getText('description', $language->language, $pm) . '</p>'
            );
            break;

        case 'gc_sofortuw':
            $form['girocheckout_sofortuw_info'] = array(
                '#markup' => '<p><img src="' . base_path() . drupal_get_path('module', 'uc_girocheckout') . '/img/gc_sofortuw.jpg" alt="' . GiroCheckout_Utility::getText('title', $language->language, $pm) . '" style="float:left; margin:-5px 5px 0px 0px;">'
                . GiroCheckout_Utility::getText('title', $language->language, $pm) . '<br/><br/>' . GiroCheckout_Utility::getText('description', $language->language, $pm) . '</p>'
            );
            break;
    }
}

/**
 * TODO
 *
 * @param string $pm
 *   TODO
 * @param object $order
 *   TODO
 *
 * @return bool
 *   TODO
 */
function _uc_girocheckout_uc_cart_process($pm, &$order) {
    if (!isset($order->payment_details)) {
        $order->payment_details = array();
    }
    switch ($pm) {
        case 'gc_directdebit':
		    case 'gc_giropay':
        case 'gc_creditcard':
        case 'gc_ideal':
		    case 'gc_eps':
		    case 'gc_paydirekt':
		    case 'gc_sofortuw':
            break;
  }
    return TRUE;
}

/**
 * TODO
 *
 * @param object $order
 *   TODO
 * @param string $key
 *   TODO
 */
function _uc_girocheckout_uc_cart_process_value(&$order, $key, $subkey = '') {
    if (strlen($subkey) > 0) {
        $value = empty($_POST['panes']['payment']['details'][$key][$subkey]) ? '' : check_plain($_POST['panes']['payment']['details'][$key][$subkey]);
        $order->payment_details[$key][$subkey] = $value;
    } else {
        $value = empty($_POST['panes']['payment']['details'][$key]) ? '' : check_plain($_POST['panes']['payment']['details'][$key]);
        $order->payment_details[$key] = $value;
    }
}

/**
 * TODO
 *
 * @param string $pm
 *   TODO
 * @param object $order
 *   TODO
 *
 * @return array
 *   TODO
 */
function _uc_girocheckout_uc_cart_review($pm, $order) {
    global $language;

    $review = array();

    switch ($pm) {
        case 'gc_directdebit':
		    case 'gc_giropay':
        case 'gc_creditcard':
        case 'gc_ideal':
		    case 'gc_eps':
		    case 'gc_paydirekt':
		    case 'gc_sofortuw':
            break;
    }
    return $review;
}

/**
 * TODO
 *
 * @param object $order
 *   TODO
 */
function _uc_girocheckout_uc_save_details($order) {
    // Load up the existing data array.
    $data = db_select('uc_orders', 'o')
            ->fields('o', array('data'))
            ->condition('o.order_id', $order->order_id)
            ->execute()
            ->fetchField();
    if (!empty($data)) {
        $data = unserialize($data);
    }

    switch ($order->payment_method) {
        case 'gc_directdebit':
		    case 'gc_giropay':
        case 'gc_creditcard':
        case 'gc_ideal':
		    case 'gc_eps':
		    case 'gc_paydirekt':
		    case 'gc_sofortuw':
            break;


        
    }
    db_update('uc_orders')
            ->fields(array('data' => serialize($data)))
            ->condition('order_id', $order->order_id)
            ->execute();
}

/**
 * TODO
 *
 * @param object $order
 *   TODO
 */
function _uc_girocheckout_uc_load_details(&$order) {
    // Load up the existing data array.
    $data = db_select('uc_orders', 'o')
            ->fields('o', array('data'))
            ->condition('o.order_id', $order->order_id)
            ->execute()
            ->fetchField();
    if (empty($data)) {
        return;
    }
    $data = unserialize($data);
    switch ($order->payment_method) {
        case 'gc_directdebit':
		    case 'gc_giropay':
        case 'gc_creditcard':
        case 'gc_ideal':
		    case 'gc_eps':
		    case 'gc_paydirekt':
		    case 'gc_sofortuw':
            break;

    }
}

function _uc_girocheckout_uc_start_payment($order) {
    global $language;

    $bRequestOK = false;
    $strErrorMsg = "";
    $paymentMsg = "";
    $pm = $order->payment_method;
    $amount = number_format(uc_currency_format($order->order_total * 100, FALSE, FALSE, '.'), 0, '', '');

    $currency = variable_get('uc_currency_code', "EUR");
    $text = GiroCheckout_Utility::getPurpose(variable_get($pm . '_purpose', ''), $order);
    $urlRedirect = url('admin/uc_girocheckout/uc_redirect', array('absolute' => TRUE, 'query' => array('pm' => $pm)));
    $urlNotify = url('admin/uc_girocheckout/uc_notify', array('absolute' => TRUE, 'query' => array('pm' => $pm)));

    $settings = uc_girocheckout_get_pm_settings($pm);

    if ((!isset($settings[$pm . '_mid']) || empty($settings[$pm . '_mid']) ) ||
            (!isset($settings[$pm . '_pid']) || empty($settings[$pm . '_pid'])) ||
            (!isset($settings[$pm . '_secret']) || empty($settings[$pm . '_secret']))) {
        $strErrorMsg = GiroCheckout_Utility::getText('settings_missing', $language->language);
        drupal_set_message($strErrorMsg, 'warning');
        drupal_goto('cart/checkout');
        exit;
    }

    switch ($pm) {
        case 'gc_giropay':
            try {
	            // Sends request to Girocheckout.
	            $reqPayment = new GiroCheckout_SDK_Request('giropayTransaction');
	            $reqPayment->setSecret(variable_get($pm . '_secret', ''));
	            $reqPayment->addParam('merchantId', variable_get($pm . '_mid', ''))
						             ->addParam('projectId', variable_get($pm . '_pid', ''))
						             ->addParam('merchantTxId', (int) $order->order_id)
						             ->addParam('amount', $amount)
						             ->addParam('currency', $currency)
						             ->addParam('purpose', $text)
						             ->addParam('urlRedirect', $urlRedirect)
						             ->addParam('urlNotify', $urlNotify)
						             ->addParam('sourceId', GiroCheckout_Utility::getGcSource())
						             ->addParam('orderId', (int) $order->order_id)
						             ->addParam('customerId', $order->uid)
						             ->submit();

	            if ($reqPayment->requestHasSucceeded()) {
		            $strUrlRedirect = $reqPayment->getResponseParam('redirect');
		            drupal_goto($strUrlRedirect, array('external' => TRUE));
		            $bRequestOK = true;
	            } else {
		            $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage($reqPayment->getResponseParam('rc'), $language->language);
	            }

            } catch (Exception $e) {
                $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage(5100, $language->language);
            }
            break;

        case 'gc_directdebit':
            try {
	            $request = new GiroCheckout_SDK_Request('directDebitTransactionWithPaymentPage');
	            $request->setSecret(variable_get($pm . '_secret', ''));
	            $request->addParam('merchantId', variable_get($pm . '_mid', ''))
					            ->addParam('projectId', variable_get($pm . '_pid', ''))
					            ->addParam('merchantTxId', (int) $order->order_id)
					            ->addParam('amount', $amount)
					            ->addParam('currency', $currency)
					            ->addParam('purpose', $text)
					            ->addParam('urlRedirect', $urlRedirect)
					            ->addParam('urlNotify', $urlNotify)
					            ->addParam('sourceId', GiroCheckout_Utility::getGcSource())
					            ->addParam('orderId', (int) $order->order_id)
					            ->addParam('customerId', $order->uid)
					            ->submit();

	            if ($request->requestHasSucceeded()) {
		            $strUrlRedirect = $request->getResponseParam('redirect');
		            drupal_goto($strUrlRedirect, array('external' => TRUE));
		            $bRequestOK = true;
	            } else {
		            $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage($request->getResponseParam('rc'), $language->language);
	            }
            } catch (Exception $e) {
                $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage(5100, $language->language);
            }
            break;

        case 'gc_creditcard':
            try {
                $request = new GiroCheckout_SDK_Request('creditCardTransaction');
                $request->setSecret(variable_get($pm . '_secret', ''));
                $request->addParam('merchantId', variable_get($pm . '_mid', ''))
                        ->addParam('projectId', variable_get($pm . '_pid', ''))
                        ->addParam('merchantTxId', (int) $order->order_id)
                        ->addParam('amount', $amount)
                        ->addParam('currency', $currency)
                        ->addParam('purpose', $text)
                        ->addParam('locale', $language->language)
                        ->addParam('urlRedirect', $urlRedirect)
                        ->addParam('urlNotify', $urlNotify)
                        ->addParam('sourceId', GiroCheckout_Utility::getGcSource())
                        ->addParam('orderId', (int) $order->order_id)
                        ->addParam('customerId', $order->uid)
                        ->submit();

                if ($request->requestHasSucceeded()) {
                    $strUrlRedirect = $request->getResponseParam('redirect');
                    drupal_goto($strUrlRedirect, array('external' => TRUE));
                    $bRequestOK = true;
                } else {
                    $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage($request->getResponseParam('rc'), $language->language);
                }
            } catch (Exception $e) {
                $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage(5100, $language->language);
            }
            break;

        case 'gc_ideal':
            try {
                //Sends request to Girocheckout.
                $request = new GiroCheckout_SDK_Request('idealPayment');
                $request->setSecret(variable_get($pm . '_secret', ''));
                $request->addParam('merchantId', variable_get($pm . '_mid', ''))
                        ->addParam('projectId', variable_get($pm . '_pid', ''))
                        ->addParam('merchantTxId', (int) $order->order_id)
                        ->addParam('amount', $amount)
                        ->addParam('currency', $currency)
                        ->addParam('purpose', $text)
                        ->addParam('urlRedirect', $urlRedirect)
                        ->addParam('urlNotify', $urlNotify)
                        ->addParam('sourceId', GiroCheckout_Utility::getGcSource())
                        ->addParam('orderId', (int) $order->order_id)
                        ->addParam('customerId', $order->uid)
                        ->submit();

                if ($request->requestHasSucceeded()) {
                    $strUrlRedirect = $request->getResponseParam('redirect');
                    drupal_goto($strUrlRedirect, array('external' => TRUE));
                    $bRequestOK = true;
                } else {
                    $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage($request->getResponseParam('rc'), $language->language);
                }
            } catch (Exception $e) {
                $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage(5100, $language->language);
            }
            break;

        case 'gc_eps':
            try {
	            //Sends request to Girocheckout.
	            $reqPayment = new GiroCheckout_SDK_Request('epsTransaction');
	            $reqPayment->setSecret(variable_get($pm . '_secret', ''));
	            $reqPayment->addParam('merchantId', variable_get($pm . '_mid', ''))
						             ->addParam('projectId', variable_get($pm . '_pid', ''))
						             ->addParam('merchantTxId', (int) $order->order_id)
						             ->addParam('amount', $amount)
						             ->addParam('currency', $currency)
						             ->addParam('purpose', $text)
						             ->addParam('urlRedirect', $urlRedirect)
						             ->addParam('urlNotify', $urlNotify)
						             ->addParam('sourceId', GiroCheckout_Utility::getGcSource())
						             ->addParam('orderId', (int) $order->order_id)
						             ->addParam('customerId', $order->uid)
						             ->submit();

	            if ($reqPayment->requestHasSucceeded()) {
		            $strUrlRedirect = $reqPayment->getResponseParam('redirect');
		            drupal_goto($strUrlRedirect, array('external' => TRUE));
		            $bRequestOK = true;
	            } else {
		            $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage($reqPayment->getResponseParam('rc'), $language->language);
	            }

            } catch (Exception $e) {
                $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage(5100, $language->language);
            }
            break;

        case 'gc_sofortuw':
            try {
                $request = new GiroCheckout_SDK_Request('sofortuwTransaction');
                $request->setSecret(variable_get($pm . '_secret', ''));
                $request->addParam('merchantId', variable_get($pm . '_mid', ''))
                        ->addParam('projectId', variable_get($pm . '_pid', ''))
                        ->addParam('merchantTxId', (int) $order->order_id)
                        ->addParam('amount', $amount)
                        ->addParam('currency', $currency)
                        ->addParam('purpose', $text)
                        ->addParam('urlRedirect', $urlRedirect)
                        ->addParam('urlNotify', $urlNotify)
                        ->addParam('sourceId', GiroCheckout_Utility::getGcSource())
                        ->addParam('orderId', (int) $order->order_id)
                        ->addParam('customerId', $order->uid)
                        ->submit();

                if ($request->requestHasSucceeded()) {
                    $strUrlRedirect = $request->getResponseParam('redirect');
                    drupal_goto($strUrlRedirect, array('external' => TRUE));
                    $bRequestOK = true;
                } else {
                    $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage($request->getResponseParam('rc'), $language->language);
                }
            } catch (Exception $e) {
                $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage(5100, $language->language);
            }
            break;      

        case 'gc_paydirekt':
            try {
                $oCart = new GiroCheckout_SDK_Request_Cart();
                $iPriceProducts = 0;

                if (!empty($order->products)) {
                    foreach ($order->products as $item) {
                        $nombre = strlen($item->title) > 100 ? substr($item->title, 0, 90) . '...' : $item->title;
                        $price = $item->qty*$item->price;
                        $iPriceProducts += $price;
                        $price = number_format(uc_currency_format($price * 100, FALSE, FALSE, '.'), 0, '', '');
                        $oCart->addItem($nombre, $item->qty, $price, "");
                    }
                }                
                $iPriceShipping = $order->order_total - $iPriceProducts;
                $country = uc_get_country_data(array('country_id' => $order->delivery_country));

                $request = new GiroCheckout_SDK_Request('paydirektTransaction');
                $request->setSecret(variable_get($pm . '_secret', ''));
                $request->addParam('merchantId', variable_get($pm . '_mid', ''))
                        ->addParam('projectId', variable_get($pm . '_pid', ''))
                        ->addParam('merchantTxId', (int) $order->order_id)
                        ->addParam('amount', $amount)
                        ->addParam('currency', $currency)
                        ->addParam('purpose', $text)
                        ->addParam('shippingAmount', number_format(uc_currency_format($iPriceShipping * 100, FALSE, FALSE, '.'), 0, '', ''))
                        ->addParam('shippingAddresseFirstName', GiroCheckout_Utility::formatText($order->delivery_first_name))
                        ->addParam('shippingAddresseLastName', GiroCheckout_Utility::formatText($order->delivery_last_name))
                        ->addParam('shippingCompany', GiroCheckout_Utility::formatText($order->delivery_company))
                        ->addParam('shippingAdditionalAddressInformation', GiroCheckout_Utility::formatText($order->delivery_street2))
                        ->addParam('shippingStreet', GiroCheckout_Utility::formatText($order->delivery_street1))
                        ->addParam('shippingZipCode', $order->delivery_postal_code)
                        ->addParam('shippingCity', GiroCheckout_Utility::formatText($order->delivery_city))
                        ->addParam('shippingCountry', $country[0]['country_iso_code_2'])
                        ->addParam('orderAmount', number_format(uc_currency_format($iPriceProducts * 100, FALSE, FALSE, '.'), 0, '', ''))
                        ->addParam('customerMail', $order->primary_email)
                        ->addParam('cart', $oCart)
                        ->addParam('urlRedirect', $urlRedirect)
                        ->addParam('urlNotify', $urlNotify)
                        ->addParam('sourceId', GiroCheckout_Utility::getGcSource())
                        ->addParam('orderId', (int) $order->order_id)
                        ->addParam('customerId', $order->uid)
                        ->submit();

                if ($request->requestHasSucceeded()) {
                    $strUrlRedirect = $request->getResponseParam('redirect');
                    drupal_goto($strUrlRedirect, array('external' => TRUE));
                    $bRequestOK = true;
                } else {
                    $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage($request->getResponseParam('rc'), $language->language);
                }
            } catch (Exception $e) {
                $strErrorMsg = GiroCheckout_SDK_ResponseCode_helper::getMessage(5100, $language->language);
            }
            break;            
    }

    if ($bRequestOK) {
        unset($_SESSION['uc_checkout'][$order->order_id]['do_review']);
        $_SESSION['girocheckout'] = array(
            'order_id' => $order->order_id
        );
    } else {
        drupal_set_message($strErrorMsg, 'warning');
        drupal_goto('cart/checkout');
    }
}
